@ ECHO off > \dev\nul
  ECHO off > \dev\nul
  IF NOT ""=="%1" GOTO start
  REM -------------------------------------------------------------------------
  REM Requires : DOS 3.0/3.3+
  REM Last Edit: 1997-03-22 -mp [Matthias.Paul@post.rwth-aachen.de]
  REM Comments : To be compatible with any known DOS command processor, this
  REM            is the easiest way to get the current ErrorLevel under
  REM            virtually any circumstances.
  REM            Some alternatives, such as 4DOS/NDOS, provide much better
  REM            support to ErrorLevel. Sometimes, external utilities can be
  REM            used instead, but mind, that those tools are processed in
  REM            another context than inside of a batchjob and therefore may
  REM            show different results.
  REM            Note, that CCI Multiuser DOS 7.22 Gold provides a pseudo 
  REM            variable %ErrorLvl% for a similar purpose, but always with
  REM            three digits (leading zeros).
  REM -------------------------------------------------------------------------
  :help
  ECHO ERRORLVL  V1.12  (C) 1993-1997 by Matthias Paul
  ECHO 
  ECHO  This is a wrapping batchjob for any DOS command to show its ErrorLevel
  ECHO  when returning to the prompt. Additionally, it sets an environment
  ECHO  variable "errorlvl" to the corresponding value.
  ECHO 
  ECHO  ERRORLVL [-] [CALL] cmd [params]
  ECHO  whereas  [-]    = don't use leading zeros (three digits)
  ECHO           CALL   = necessary for 'cmd' being a batchjob
  ECHO                    (With DOS before 3.3, environment variable ComSpec may be
  ECHO                    used instead, but this may not show correct ErrorLevels.)
  ECHO           cmd    = command to be executed
  ECHO           params = parameters to 'cmd'
  ECHO 
  GOTO end

  :start
  SET param=%1%2%3%4%5%6%7%8%9> \dev\nul
  IF NOT "%param%"=="%1%2%3%4%5%6%7%8%9" GOTO error1
  SET lz=0> \dev\nul
  IF NOT "-"=="%1%" GOTO lz
  SET lz=> \dev\nul
  SHIFT
  IF ""=="%1" GOTO help
  :lz
  SET param=%1 %2 %3 %4 %5 %6 %7 %8 %9> \dev\nul
  IF ""=="%param%" GOTO error1
  SHIFT
  SHIFT
  SHIFT
  SHIFT
  SHIFT
  SHIFT
  SHIFT
  SHIFT
  SHIFT
  :continue
@ %param% %1 %2 %3 %4 %5 %6 %7 %8 %9
  SET param=> \dev\nul
  ECHO 

  REM Not to make errorlvl permanent: IF "MDOS"=="%Os%" GOTO result

  SET _1=%lz%> \dev\nul
  SET _2=%lz%> \dev\nul
  SET _3=%lz%> \dev\nul
  IF NOT "%lz%"=="%_1%" GOTO error2
  IF NOT "%lz%"=="%_2%" GOTO error2
  IF NOT "%lz%"=="%_3%" GOTO error2
  
  FOR %%x IN (1 2) DO IF ERRORLEVEL %%x00 SET _1=%%x> \dev\nul
  IF ERRORLEVEL 100 IF ""=="%_1%" GOTO error2
  FOR %%x IN (0 1 2 3 4 5) DO IF ERRORLEVEL %_1%%%x0 SET _2=%%x> \dev\nul
  IF NOT "2"=="%_1%" FOR %%x IN (6 7 8 9) DO IF ERRORLEVEL %_1%%%x0 SET _2=%%x> \dev\nul
  IF ERRORLEVEL 10 IF ""=="%_2%" GOTO error2
  IF NOT "0"=="%lz%" IF ""=="%_1%" IF "0"=="%_2%" SET _2=> \dev\nul
  FOR %%x IN (0 1 2 3 4 5) DO IF ERRORLEVEL %_1%%_2%%%x SET _3=%%x> \dev\nul
  IF "2"=="%_1%" IF "5"=="%_2%" GOTO skip
  FOR %%x IN (6 7 8 9) DO IF ERRORLEVEL %_1%%_2%%%x SET _3=%%x> \dev\nul
  :skip
  IF ""=="%_3%" GOTO error2
  SET errorlvl=%_1%%_2%%_3%> \dev\nul
  :result
  IF NOT ""=="%errorlvl%" ECHO  Returned Errorlevel is %errorlvl%.

  :exit
  SET _1=> \dev\nul
  SET _2=> \dev\nul
  SET _3=> \dev\nul
  GOTO end

  :error2
  ECHO  Error: Environment much too small, processing aborted...
  GOTO exit

  :error1
  SET param=> \dev\nul
  ECHO  Error: Environment too small, continuing anyway...
  GOTO continue

  :end
  SET lz=> \dev\nul
  REM To avoid a parser bug in an older MS-DOS COMMAND.COM release.
  REM
